def RAMA = env.BRANCH_NAME
def PROJECT_ROOT = 'express-mysql/app'
def CRON_SETTINGS = ''

switch(RAMA){
    case "develop":
        CRON_SETTINGS = '0 18 * * 1-5'
        break;
    case "main":
        break;
    case "release":
        CRON_SETTINGS = '0 19 * * 1-5'
        break;
}


node{

    properties([pipelineTriggers([cron(CRON_SETTINGS)])])


    stage ('Hola mundo') {
        sh "echo 'Hola mundo ${RAMA}'"
    }

    stage ('clone_repo') {
        git branch: RAMA, credentialsId: 'GitLab-Auth-SSH-Key', url: 'https://gitlab.com/santiago.posada/docker-pirate.git'
    }
    
  
    
    stage('Install dependencies') {
        
        env.NODEJS_HOME = tool name : 'nodejs', type: 'nodejs'
        env.PATH="${env.NODEJS_HOME}/bin:${env.PATH}"
        sh 'node -v'
        sh 'npm --version'
        sh "cd ${PROJECT_ROOT}; npm install"
 
    
    }
    stage('Unit tests') {
        
        // Run unit tests
        sh "cd ${PROJECT_ROOT}; npm run test"
        
    }
    stage('Generate coverage report') {
        
            // Run code-coverage reports
        sh "cd ${PROJECT_ROOT}; npm run coverage"
        
    }
    stage('scan') {
          
        env.scannerHome = tool name: 'sonar-scanner'
          
          
        // "sonarqube" is the server configured in "Configure System"
        withSonarQubeEnv('sonarqube') {
            // Execute the SonarQube scanner with desired flags
            sh "${scannerHome}/bin/sonar-scanner \
                        -Dsonar.projectKey=SimpleExpressExample:Test \
                        -Dsonar.projectName=SimpleExpressExample \
                        -Dsonar.projectVersion=0.0.${BUILD_NUMBER} \
                        -Dsonar.host.url=http://mysonarqube:9000 \
                        -Dsonar.sources=./${PROJECT_ROOT}/app.js,./${PROJECT_ROOT}/config/db.config.js,./${PROJECT_ROOT}/routes/developers.js \
                        -Dsonar.login=admin \
                        -Dsonar.password=admin \
                        -Dsonar.tests=./${PROJECT_ROOT}/test \
                        -Dsonar.javascript.lcov.reportPaths=./${PROJECT_ROOT}/coverage/lcov.info"
        }
        timeout(time: 3, unit: 'MINUTES') {
            // In case of SonarQube failure or direct timeout exceed, stop Pipeline
            waitForQualityGate abortPipeline: qualityGateValidation(waitForQualityGate())
        }
          
      }
}


def qualityGateValidation(qg) {
    if (qg.status != 'OK') {
        return true
    }else{
        return false  
    }
    
}

def getCronParams() {
    if( RAMA == "develop" ) {
        return '0 19 * * 1-5'
    }
}

